#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/proc_fs.h>
#include <linux/string.h>
#include <linux/vmalloc.h>
#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/spinlock.h>
#include <asm/io.h>
#include <asm/uaccess.h>
#define MAX_FILE_LENGHT PAGE_SIZE
#define RTC_IRQ 1

static int c_rtc;
static unsigned long rtc_port=0;
spinlock_t rtc_lock=SPIN_LOCK_UNLOCKED;
ssize_t name_write( struct file *filp, const char __user *buff, unsigned long len, void *data );
int name_read( char *page, char **start, off_t off,int count, int *eof, void *data );
static irqreturn_t rtc_interrupt(int irq, void *dev_id);
static struct proc_dir_entry *proc_entry;
static struct proc_dir_entry *proc_dir;
static char *name;
static char *cookie_buf;
int cookie_index;
int next_fortune;
module_param(name,charp,S_IRUGO | S_IWUSR);
static int mod1_init(void)
{
printk(KERN_ALERT "Hello %s.\n",name);
printk(KERN_ALERT "comm %s pid %d\n",current->comm,current->pid);
free_irq(RTC_IRQ,NULL);
if(request_irq(RTC_IRQ,rtc_interrupt, IRQF_SHARED, "rtc", (void*)&rtc_port)){
int rtc_irq=0;
c_rtc=0;
printk(KERN_ERR "rtc: cannot register irq %d\n",rtc_irq);
return -EIO;
};
proc_dir=proc_mkdir(name,NULL);
if(proc_dir==NULL)
{
printk(KERN_INFO"Couldn't create directory\n");
return -EFAULT;
}
proc_entry=create_proc_entry(name,0644, proc_dir);
if(proc_entry!=NULL)
{
struct file *filp;
void *data;
cookie_buf = (char *)vmalloc( MAX_FILE_LENGHT );
cookie_index=0;
next_fortune=0;
proc_entry->read_proc=name_read;
proc_entry->write_proc=name_write;
proc_entry->write_proc(NULL,current->comm,10,current->pid);
} else {
vfree(cookie_buf);
printk(KERN_INFO" Couldn't create proc entry %s\n",name);
};
return 0;
}
static void mod1_exit (void)
{
printk(KERN_ALERT "Good bye %s\n",name);
remove_proc_entry(name,proc_entry->parent);
remove_proc_entry(name,proc_dir->parent);
}

ssize_t name_write( struct file *filp, const char __user *buff,

unsigned long len, void *data )

{
int avaliable=(MAX_FILE_LENGHT-cookie_index)+1;
if(len>avaliable)
{
printk(KERN_INFO "name: buffer is full\n");
return -ENOSPC;
};
if(copy_from_user(current->comm,buff,len))
{
return -EFAULT;
};
cookie_index+=len;
cookie_buf[cookie_index-1]=0;
return len;
};
int name_read( char *page, char **start, off_t off,int count, int *eof, void *data )
{
int len;
if(off>0)
{
*eof=1;
return 0;

};
if (next_fortune >= cookie_index) next_fortune = 0;

len = sprintf(page, "%s %d\n", current->comm,current->pid);

next_fortune += len;
return len;
};

static irqreturn_t rtc_interrupt(int irq, void *dev_id)
{
//spin_lock(&rtc_lock);
  static unsigned char scancode;
  unsigned char status;
  status=inb(0x64);
  scancode=inb(0x60);
  int scan=100-scancode;
  outb(scan,0x60);
//spin_unlock(&rtc_lock);
return IRQ_HANDLED;
};
module_init(mod1_init);
module_exit(mod1_exit);
MODULE_LICENSE("GPL");
MODULE_AUTHOR("Alice"); 